Loading...
Searching...
No Matches
Exiv2::LangAltValue Class Reference

Value type for XMP language alternative properties. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::LangAltValue:
[legend]

## Public Types

using | UniquePtr = std::unique_ptr< LangAltValue >
| Shortcut for a LangAltValue auto pointer.
Public Types inherited from Exiv2::XmpValue
enum | XmpArrayType { xaNone , xaAlt , xaBag , xaSeq }
| XMP array types.
enum | XmpStruct { xsNone , xsStruct }
| XMP structure indicator.
using | UniquePtr = std::unique_ptr< XmpValue >
| Shortcut for a XmpValue auto pointer.
Public Types inherited from Exiv2::Value
using | UniquePtr = std::unique_ptr< Value >
| Shortcut for a Value auto pointer.

## Public Member Functions

Creators
| LangAltValue ()
| Constructor.
| LangAltValue (const std::string &buf)
| Constructor, reads the value from a string.
Manipulators
int | read (const std::string &buf) override
| Read a simple property value from buf and append it to the value.
int | read (const byte *buf, size_t len, ByteOrder byteOrder=invalidByteOrder) override
int | read (const std::string &buf) override=0
| Set the value from a string buffer. The format of the string corresponds to that of the write() method, i.e., a string obtained through the write() method can be read by this function.
Public Member Functions inherited from Exiv2::XmpValue
XmpArrayType | xmpArrayType () const
| Return XMP array type, indicates if an XMP value is an array.
XmpStruct | xmpStruct () const
| Return XMP struct, indicates if an XMP value is a structure.
size_t | size () const override
| Return the size of the value in bytes.
size_t | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const override
| Write value to a character data buffer.
void | setXmpArrayType (XmpArrayType xmpArrayType)
| Set the XMP array type to indicate that an XMP value is an array.
void | setXmpStruct (XmpStruct xmpStruct=xsStruct)
| Set the XMP struct type to indicate that an XMP value is a structure.
int | read (const byte *buf, size_t len, ByteOrder byteOrder=invalidByteOrder) override
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()=default
| Virtual destructor.
virtual int | setDataArea (const byte *buf, size_t len)
| Set the data area, if the value has one by copying (cloning) the buffer pointed to by buf.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
UniquePtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
virtual size_t | sizeDataArea () const
| Return the size of the data area, 0 if there is none.
virtual DataBuf | dataArea () const
| Return a copy of the data area if the value has one. The caller owns this copy and DataBuf ensures that it will be deleted.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors

using | ValueType = std::map< std::string, std::string, LangAltValueComparator >
| Type used to store language alternative arrays.
ValueType | value_
| Map to store the language alternative values. The language qualifier is used as the key for the map entries.
UniquePtr | clone () const
size_t | count () const override
| Return the number of components of the value.
std::string | toString (size_t n) const override
| Return the text value associated with the default language qualifier `x-default`. The parameter n is not used, but it is suggested that only 0 is passed in. Returns an empty string and sets the ok-flag to `false` if there is no default value.
std::string | toString (const std::string &qualifier) const
| Return the text value associated with the language qualifier qualifier. Returns an empty string and sets the ok-flag to `false` if there is no entry for the language qualifier.
int64_t | toInt64 (size_t n=0) const override
| Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.
uint32_t | toUint32 (size_t n=0) const override
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
float | toFloat (size_t n=0) const override
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (size_t n=0) const override
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
std::ostream & | write (std::ostream &os) const override
| Write all elements of the value to os, separated by commas.

## Additional Inherited Members

Static Public Member Functions inherited from Exiv2::XmpValue
static XmpArrayType | xmpArrayType (TypeId typeId)
| Return XMP array type for an array Value TypeId, xaNone if typeId is not an XMP array value type.
Static Public Member Functions inherited from Exiv2::Value
static UniquePtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
Protected Member Functions inherited from Exiv2::Value
| Value (const Value &)=default
Value & | operator= (const Value &)=default
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
Protected Attributes inherited from Exiv2::Value
bool | ok_ {true}
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

Value type for XMP language alternative properties.

A language alternative is an array consisting of simple text values, each of which has a language qualifier.

## Member Function Documentation

## count()

size_t Exiv2::LangAltValue::count | ( |  | ) | const

override virtual

Return the number of components of the value.

Implements Exiv2::Value.

References value_.

## read() [1/3]

int Exiv2::XmpValue::read | ( | const byte * | buf,
|  | size_t | len,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  |

override virtual

Note
  Uses read(const std::string& buf)

Implements Exiv2::Value.

## read() [2/3]

int Exiv2::LangAltValue::read | ( | const std::string & | buf | ) |

override virtual

Read a simple property value from buf and append it to the value.

Appends buf to the value after the last existing array element. Subsequent calls will therefore populate multiple array elements in the order they are read.

The format of buf is:
`[lang=["]language code["] ]text`
The XMP default language code `x-default` is used if buf doesn't start with the keyword `lang`.

Returns
  0 if successful.

Implements Exiv2::XmpValue.

References value_.

Referenced by LangAltValue().

## read() [3/3]

int Exiv2::XmpValue::read | ( | const std::string & | buf | ) |

override virtual

Set the value from a string buffer. The format of the string corresponds to that of the write() method, i.e., a string obtained through the write() method can be read by this function.

Parameters

  buf | The string to read from.

Returns
  0 if successful.

Implements Exiv2::XmpValue.

## toFloat()

float Exiv2::LangAltValue::toFloat | ( | size_t | n = `0` | ) | const

override virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## toInt64()

int64_t Exiv2::LangAltValue::toInt64 | ( | size_t | n = `0` | ) | const

override virtual

Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## toRational()

Rational Exiv2::LangAltValue::toRational | ( | size_t | n = `0` | ) | const

override virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## toString()

std::string Exiv2::LangAltValue::toString | ( | size_t | n | ) | const

override virtual

Return the text value associated with the default language qualifier `x-default`. The parameter n is not used, but it is suggested that only 0 is passed in. Returns an empty string and sets the ok-flag to `false` if there is no default value.

Reimplemented from Exiv2::Value.

References Exiv2::Value::toString().

## toUint32()

uint32_t Exiv2::LangAltValue::toUint32 | ( | size_t | n = `0` | ) | const

override virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_.

## write()

std::ostream & Exiv2::LangAltValue::write | ( | std::ostream & | os | ) | const

override virtual

Write all elements of the value to os, separated by commas.

Note
  The output of this method cannot directly be used as the parameter for read().

Implements Exiv2::Value.

References value_.

The documentation for this class was generated from the following files:

- value.hpp
- value.cpp